package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.UserGroup;
import com.sa.ibiz.demo.demo.domain.UserObject;

/**
 * 实体[UserGroupDetail] 数据对象
 */
@TableName(value = "T_SRFUSERGROUPDETAIL",resultMap = "UserGroupDetailResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class UserGroupDetail extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private UserGroup usergroup;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private UserObject userobject;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String userdata;
    private String userdata2;
    @TableId(value= "usergroupdetailid",type=IdType.UUID)//指定主键生成策略
    private String usergroupdetailid;
    private String usergroupdetailname;
    private String usergroupid;
    @TableField(exist = false)//逻辑属性
    private String usergroupname;
    private String userobjectid;
    @TableField(exist = false)//逻辑属性
    private String userobjectname;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[用户数据]
     *  @param userdata
     */
    public void setUserdata(String userdata){
        if(StringUtils.isEmpty(userdata))
            userdata=null;
        this.userdata = userdata;
        this.set("userdatadirtyflag",true);
    }
    /**
     *  获取属性值[用户数据]
     */
    public String getUserdata(){
        return this.userdata;
    }
    /**
     *  重置属性值[用户数据]
     */
    public void resetUserdata(){
        this.set("userdatadirtyflag",false);
        this.userdata = null;
    }
    /**
     *  设置属性值[用户数据2]
     *  @param userdata2
     */
    public void setUserdata2(String userdata2){
        if(StringUtils.isEmpty(userdata2))
            userdata2=null;
        this.userdata2 = userdata2;
        this.set("userdata2dirtyflag",true);
    }
    /**
     *  获取属性值[用户数据2]
     */
    public String getUserdata2(){
        return this.userdata2;
    }
    /**
     *  重置属性值[用户数据2]
     */
    public void resetUserdata2(){
        this.set("userdata2dirtyflag",false);
        this.userdata2 = null;
    }
    /**
     *  设置属性值[用户组成员标识]
     *  @param usergroupdetailid
     */
    public void setUsergroupdetailid(String usergroupdetailid){
        if(StringUtils.isEmpty(usergroupdetailid))
            usergroupdetailid=null;
        this.usergroupdetailid = usergroupdetailid;
        this.set("usergroupdetailiddirtyflag",true);
    }
    /**
     *  获取属性值[用户组成员标识]
     */
    public String getUsergroupdetailid(){
        return this.usergroupdetailid;
    }
    /**
     *  重置属性值[用户组成员标识]
     */
    public void resetUsergroupdetailid(){
        this.set("usergroupdetailiddirtyflag",false);
        this.usergroupdetailid = null;
    }
    /**
     *  设置属性值[用户组成员名称]
     *  @param usergroupdetailname
     */
    public void setUsergroupdetailname(String usergroupdetailname){
        if(StringUtils.isEmpty(usergroupdetailname))
            usergroupdetailname=null;
        this.usergroupdetailname = usergroupdetailname;
        this.set("usergroupdetailnamedirtyflag",true);
    }
    /**
     *  获取属性值[用户组成员名称]
     */
    public String getUsergroupdetailname(){
        return this.usergroupdetailname;
    }
    /**
     *  重置属性值[用户组成员名称]
     */
    public void resetUsergroupdetailname(){
        this.set("usergroupdetailnamedirtyflag",false);
        this.usergroupdetailname = null;
    }
    /**
     *  设置属性值[用户组]
     *  @param usergroupid
     */
    public void setUsergroupid(String usergroupid){
        if(StringUtils.isEmpty(usergroupid))
            usergroupid=null;
        this.usergroupid = usergroupid;
        this.set("usergroupiddirtyflag",true);
    }
    /**
     *  获取属性值[用户组]
     */
    public String getUsergroupid(){
        return this.usergroupid;
    }
    /**
     *  重置属性值[用户组]
     */
    public void resetUsergroupid(){
        this.set("usergroupiddirtyflag",false);
        this.usergroupid = null;
    }
    /**
     *  设置属性值[用户组]
     *  @param usergroupname
     */
    public void setUsergroupname(String usergroupname){
        if(StringUtils.isEmpty(usergroupname))
            usergroupname=null;
        this.usergroupname = usergroupname;
        this.set("usergroupnamedirtyflag",true);
    }
    /**
     *  获取属性值[用户组]
     */
    public String getUsergroupname(){
        return this.usergroupname;
    }
    /**
     *  重置属性值[用户组]
     */
    public void resetUsergroupname(){
        this.set("usergroupnamedirtyflag",false);
        this.usergroupname = null;
    }
    /**
     *  设置属性值[用户对象]
     *  @param userobjectid
     */
    public void setUserobjectid(String userobjectid){
        if(StringUtils.isEmpty(userobjectid))
            userobjectid=null;
        this.userobjectid = userobjectid;
        this.set("userobjectiddirtyflag",true);
    }
    /**
     *  获取属性值[用户对象]
     */
    public String getUserobjectid(){
        return this.userobjectid;
    }
    /**
     *  重置属性值[用户对象]
     */
    public void resetUserobjectid(){
        this.set("userobjectiddirtyflag",false);
        this.userobjectid = null;
    }
    /**
     *  设置属性值[用户对象]
     *  @param userobjectname
     */
    public void setUserobjectname(String userobjectname){
        if(StringUtils.isEmpty(userobjectname))
            userobjectname=null;
        this.userobjectname = userobjectname;
        this.set("userobjectnamedirtyflag",true);
    }
    /**
     *  获取属性值[用户对象]
     */
    public String getUserobjectname(){
        return this.userobjectname;
    }
    /**
     *  重置属性值[用户对象]
     */
    public void resetUserobjectname(){
        this.set("userobjectnamedirtyflag",false);
        this.userobjectname = null;
    }
     /**
     *  获取主实体关联数据[UserGroup]
     */
    public UserGroup getUsergroup() {
        return usergroup;
    }
    /**
     *  设置主实体关联数据[UserGroup]
     */
    public void setUsergroup(UserGroup usergroup) {
        this.usergroup = usergroup;
    }

     /**
     *  获取主实体关联数据[UserObject]
     */
    public UserObject getUserobject() {
        return userobject;
    }
    /**
     *  设置主实体关联数据[UserObject]
     */
    public void setUserobject(UserObject userobject) {
        this.userobject = userobject;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetUpdatedate();
        resetUpdateman();
        resetUserdata();
        resetUserdata2();
        resetUsergroupdetailid();
        resetUsergroupdetailname();
        resetUsergroupid();
        resetUsergroupname();
        resetUserobjectid();
        resetUserobjectname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
    	//联合主键
        String primaryKey ="";
        primaryKey+=this.getUsergroupid();
        primaryKey+="||";
        primaryKey+=this.getUserobjectid();
        return  DigestUtils.md5DigestAsHex(primaryKey.getBytes());
    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public UserGroupDetail copyTo(UserGroupDetail targetEntity)
	{
		BeanCopier copier=BeanCopier.create(UserGroupDetail.class, UserGroupDetail.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetUsergroupdetailid();
		return targetEntity;
	}
}